#!/usr/bin/perl

BEGIN
{

    ($dirprg, $main::SCRIPT) = $0 =~ /(.+)\/(.+)/;
    unshift(@INC, "$dirprg/../lib", "$dirprg/../../lib/");
    $ENV{IANTCFG} = "$dirprg/../cfg/iANT.cfg";

}

use ParamParser;
$main::O_PARAM = New ParamParser('INIT');
$main::O_PARAM->SetAuthorizedCharacters('[&|>/0-9a-zA-Z:_.@+\#\-\s=,\?\(\)%~*!\[\]]');

use CGI qw(:standard);
use CGI::Carp qw/fatalsToBrowser/;
$main::O_CGI = new CGI;
    
use strict;
use warnings;
use HTML::Entities;

use iANT::Cfg;
use iANT::Common;

#use File::Basename;

my $O_PARAM = $main::O_PARAM;
my $O_CGI   = $main::O_CGI;

require 'EZLucene.pl';
require 'iANT/Utils.pl';

$O_PARAM->Update('CGIPM', 'A');

$O_PARAM->UnsetBehaviour('assert_value_secure');
$O_PARAM->SetBehaviour('use_substitution_table');
$O_PARAM = &iANT::Cfg::Load($O_PARAM);

MAIN:
{
    my ($dirprg, $prog) = $0 =~ /(.+)\/(.+)/;

    $O_PARAM->Update($O_PARAM->Get('cfg_dir') . '/EZLucene.cfg', 'A');

    my $lucenedb = $O_PARAM->Get('lucenedb');

    print STDOUT $O_CGI->header(), $O_CGI->start_html(-style => {'src' => '../css/EZLucene.css'}, 'EZLucene web form'),
      $O_CGI->h1('EZLucene web form');

    if (!$O_PARAM->IsDefined('lucenedb'))
    {
        &LuceneListDB();
    }
    elsif ($O_PARAM->Get('quicksearch') ne '')
    {
        $O_PARAM->AssertDefined('lucenedb');
        &Quick();
    }
    else
    {
        $O_PARAM->AssertDefined('lucenedb');
        &LuceneQuickSearchForm();
        &LuceneGenericRessources($lucenedb);
    }
    print STDOUT $O_CGI->end_html;

}

sub Quick
{

    my $lucenedb = $O_PARAM->Get('lucenedb');
    $O_PARAM->Set('cfg_indexfields', $O_PARAM->Get('lucene_cfg_'. $lucenedb));
    

    if ($O_PARAM->Get('quicksearch') ne '')
    {
        $O_PARAM->Set('store_dir', $O_PARAM->Get('lucene_index_storage') . $O_PARAM->Get('lucene_index_' . $lucenedb));
        &LucenePerformSearch($lucenedb);
    }
    else
    {
        &LuceneQuickSearchForm($lucenedb);
    }
}

